﻿@{
    List<CMSNavigation> listNavigation = ViewBag.ListNavigation;
    // Split the url to url + query string
    var fullUrl = Request.Url.AbsoluteUri;
    var questionMarkIndex = fullUrl.IndexOf('?');
    string queryString = null;
    string url = fullUrl;
    if (questionMarkIndex != -1) // There is a QueryString
    {
        url = fullUrl.Substring(0, questionMarkIndex);
        queryString = fullUrl.Substring(questionMarkIndex + 1);
    }

    // Arranges
    var request = new HttpRequest(null, url, queryString);
    var response = new HttpResponse(new StringWriter());
    var httpContext = new HttpContext(request, response);

    var routeData = RouteTable.Routes.GetRouteData(new HttpContextWrapper(httpContext));

    // Extract the data    
    var values = routeData.Values;
    var controllerName = values["controller"];
    var actionName = values["action"];


    if (controllerName.ToString().Trim() == "Receipt" && actionName.ToString().Trim() == "UploadFromExel")
    {
        controllerName = "MassUpload";
    }
}
<ul id="nav">
    @if (listNavigation.Any())
    {
        foreach (CMSNavigation nav in listNavigation.Where(x => !x.IsChild && !x.IsHide))
        {
            string currentOpen = string.Empty;
            bool isRoot = false;
            string currentRoot = string.Empty;
            if (controllerName.ToString().Trim() == nav.Controller.Trim())
            {
                currentOpen = "current";
                isRoot = true;
            }

            List<CMSNavigation> listChild = listNavigation.Where(x => x.ParentID == nav.ID && !x.IsHide).ToList();

            if (listChild.Any())
            {
                foreach (CMSNavigation childNav in listChild)
                {
                    if (controllerName.ToString().Trim() == childNav.Controller.Trim())
                    {
                        currentOpen = "current open";
                    }
                    else
                    {
                        var grandChild = listNavigation.Where(x => x.ParentID == childNav.ID && !x.IsHide).ToList();
                        foreach (CMSNavigation _grandChild in grandChild)
                        {
                            if (controllerName.ToString().Trim() == _grandChild.Controller.Trim())
                            {
                                currentOpen = "current open";
                            }
                        }
                    }
                }
            }
            currentRoot = (isRoot) ? "current" : string.Empty;
            
        <li class="@currentOpen">
            <a href="@(nav.Controller == "#" ? "#" : Url.Action("Index", nav.Controller))">
                <i class="icon-bar-chart"></i>
                @nav.Name
            </a>
            @if (listChild.Any())
            {
                <ul class="sub-menu">

                    @if (nav.Controller != "#")
                    {
@*   STATIC PARENT*@
                        <li class="@currentRoot">
                            <a href="@(nav.Controller == "#"?"#":Url.Action("Index", nav.Controller))">
                                <i class="icon-angle-right"></i>
                                @nav.Name
                            </a>
                        </li>
                    }
                    @foreach (CMSNavigation childNav in listChild)
                    {
                        var grandChild = listNavigation.Where(x => x.ParentID == childNav.ID && !x.IsHide).ToList();
                        
                        string subCurrent = string.Empty;
                        if (controllerName.ToString().Trim() == childNav.Controller.Trim())
                        {
                            subCurrent = "current";
                        }


                        if (listChild.Any())
                        {
                            foreach (CMSNavigation _grandChild in grandChild)
                            {
                                if (controllerName.ToString().Trim() == _grandChild.Controller.Trim())
                                {
                                    subCurrent = "current open";
                                }
                            }
                        }
                        //  subCurrent = (isRoot) ? "current" : string.Empty;
                        
                        
                        <li class="@subCurrent">
                            <a href="@(childNav.Controller == "#"? "#":Url.Action("Index", childNav.Controller))">
                                <i class="icon-angle-right"></i>
                                @childNav.Name
                            </a>
                            @if (grandChild.Any())
                            {
                                <ul class="sub-menu">
                                      @foreach (CMSNavigation _grandChild in grandChild)
                    {
                        string grandsubCurrent = "";
                        if (controllerName.ToString().Trim() == _grandChild.Controller.Trim())
                        {
                            grandsubCurrent = "current";
                        }
                        <li class="@grandsubCurrent">
                            <a href="@Url.Action("Index", _grandChild.Controller)">
                                <i class="icon-angle-right"></i>
                                @_grandChild.Name
                            </a>
                            </li>
                            }

                                </ul>
                            }
                        </li>
                    }
                </ul>
            }
        </li>
        }
    }
</ul>

